var app = {

  browser: null,
  geocoded: false,

  initialize: function() {

    app.bindEvents();
  },

  bindEvents: function() {

    document.addEventListener('deviceready', app.onDeviceReady, false);
  },

  onDeviceReady: function() {

    app.receivedEvent('deviceready');

    if((typeof device != "undefined") && (device.platform == "Android"))
      navigator.app.overrideBackbutton(true);
    document.addEventListener('backbutton', app.onBackKeyDown, true);

    if(navigator.network.connection.type == Connection.NONE) app.networkError();
    else app.browserLoad();
  },

  onBackKeyDown: function(e) {

  },

  receivedEvent: function(id) {

    console.log('Received Event: ' + id);
  },

  networkError: function() {

    //navigator.notification.alert('No internet connection.');

    window.open('nointernet.html');
  },

  browserLoad: function() {

    // MEHDI: ((CUSTOM)) Set client URL.
    app.browser = window.open('https://www.zulafood.com/mobile.php', '_blank', 'location=no,disallowoverscroll=yes,toolbar=yes,toolbarposition=top,clearcache=no,clearsessioncache=no');

    app.browser.addEventListener('loadstart', app.browserLoading);
    app.browser.addEventListener('loadstop', app.browserLoaded);
    app.browser.addEventListener('loaderror', app.browserError);
  },

  browserLoading: function(ref) {

    if((typeof device != "undefined") && (device.platform == "Android"))
      navigator.notification.activityStart("", "Loading...");
  },

  browserLoaded: function(ref) {

    if((typeof device != "undefined") && (device.platform == "Android"))
      navigator.notification.activityStop();

    // Remove unwanted elements.
    //app.browser.executeScript({ code: "$('.twitter-timeline').remove()" });

    // Only geocode if on main page and haven't done it yet.
    if(!app.geocoded && (app.getPage(ref.url) == '/mobile.php')) {

      navigator.notification.confirm('Would you like delivery to your current location?', function(idx) { if(idx == 1) app.doGeocode(); }, 'Welcome!', ['Yes', 'No']);
    }

    // Try to set the customer credentials if previously stored.
    if(app.getPage(ref.url) == '/mobile.php/login') {

      var rdsauth = window.localStorage.getItem('rdsauth');
      if(rdsauth) app.browser.executeScript({ code: "set_rdsauth('" + rdsauth + "')" });
    }

    if(app.getPage(ref.url) == '/mobile.php/account') {

      // Try to grab the customer credentials for storage (may or may not change from stored).
//      var credpoll = setInterval(function() {

        app.browser.executeScript({ code: "localStorage.getItem('rdsauth')" }, function(values) {

          var rdsauth = values[0];
          if(rdsauth) {

    //        clearInterval(credpoll);
            //alert('got rdsauth: ' + rdsauth);
            window.localStorage.setItem('rdsauth', rdsauth);
          }
        });
  //    });
    }
  },

  browserExecReturn: function(obj) {

    //alert(obj);
  },

  browserError: function(ref) {

    //alert('ERROR: ' + app.browser.message);
    //alert('ERROR: ' + ref.message);
  },

  doGeocode: function() {

    navigator.geolocation.getCurrentPosition(app.geoSuccess, app.geoFailure, { enableHighAccuracy: true, maximumAge: 30000, timeout: 10000 });
    app.geocoded = true;
  },

  geoSuccess: function(position) {

    var latitude = position.coords.latitude;
    var longitude = position.coords.longitude;

    //alert('geosuccess: ' + latitude + '/' + longitude);

    app.browser.executeScript({ code: "map_latlng(" + latitude + ", " + longitude + ")" });
  },

  geoFailure: function(err) {

    //alert('geofail: ' + err.code + '/' + err.message);

    if((err.code == 1) || (err.code == 2)) {

      navigator.notification.alert('You currently have location services disabled.  Please turn it on in Settings to determine your location.', function() { }, ' ', 'OK');
    }
    else {

      navigator.notification.alert('Sorry, we were unable to determine your location.', function() { }, ' ', 'OK');
    }
  },

  getPage: function(url) {

    var pieces = url.split('//')[1].split('/');
    var rel_url = '';
    for(var i = 1; i < pieces.length; ++i) rel_url += '/' + pieces[i];
    return rel_url;
  }

};

try {

  app.initialize();
} catch(e) {

  //alert(e);
}
